searchData={"items":[{"type":"module","title":"PCP","doc":"Port Control Protocol v2 Client (PCPv2, rfc6887)  implementation to control routers NAT port mapping\n\nThe code has been tested on my Fritzbox, on my network, on my planet..\n\n- Fritzbox 7490 does support the PCPv2 protocol [RFC-6887](https://datatracker.ietf.org/doc/html/rfc6887).\n  Reference: [avm doc](https://en.avm.de/service/knowledge-base/dok/FRITZ-Box-7590-AX/894_Setting-up-automatic-port-sharing/)\n\n\nIt would be interesting to build a bit of stats around this. Feel free to report about supporting routers.","ref":"PCP.html"},{"type":"function","title":"PCP.open_port_map/4","doc":"Open a port map in the router Network Address Translation (NAT) table:\n\n    {local address, inner_port}   {wan_ip_addr, outer_mapped_port}\n\nThe function sends a PCP `MAP` [IANA OpCode](https://www.iana.org/assignments/pcp-parameters/pcp-parameters.xhtml) message to the router to open an external port and map it into an internal local\nport and local address.\n\nLocal address is inferred from local router address (it's assumed to be in the same network).\n\nRouter address is inferred from the default route or can be explicitly provided.\n\nWAN address is inferred from a STUN message exchanged with Google, or it can be explicitly provided.\n\nThe Function returns the assigned external IP address and port and the lifetime of the mapping in seconds.\n\nExample:\n\n    iex> PCP.open_port_map(5555,5555)\n    {:ok, {{200,1,2,3}, 5555, 120}}\n\nNote: The assigned external port and IP can differ from the ones specified in the request, for example\nin the case where the external port is already assigned to another ongoing communication. Make\nsure to always inspect the result to know which port has been assigned to you.","ref":"PCP.html#open_port_map/4"},{"type":"type","title":"PCP.short_integer/0","doc":"","ref":"PCP.html#t:short_integer/0"},{"type":"module","title":"STUN","doc":"STUN Client implementation module","ref":"STUN.html"},{"type":"function","title":"STUN.get_wan_public_ip_addr_port/2","doc":"Perform a STUN request against Google STUN server, and retrieve router WAN IP address and mapped port.\n\nIt's than not obvious if you can use the outbound opened port from a different address / port (hole punching).\n\nYou have to verify if you have\n\n - `full-cone` NAT [Good],\n - `address-restricted-cone` NAT [Good] (you must send the packet to the addr of the peer you want to receive from),\n - `port-restricted-cone` [Good] (you must send a packet to the addr AND port of the peer you want to receive from),\n - `simmetric` NAT (meaning you can't use hole punching).","ref":"STUN.html#get_wan_public_ip_addr_port/2"},{"type":"macro","title":"STUN.stun/1","doc":"","ref":"STUN.html#stun/1"},{"type":"macro","title":"STUN.stun/2","doc":"","ref":"STUN.html#stun/2"},{"type":"module","title":"Utils","doc":"Supplies some convenience function to deal with p2p connectivity in ipv4 network.","ref":"Utils.html"},{"type":"function","title":"Utils.init/0","doc":"Loads routing table nif based on Netlink socket communication.","ref":"Utils.html#init/0"},{"type":"function","title":"Utils.local_net_ip_addr/1","doc":"Infers local network address in the router network, by connecting to the\nrouter and inspecting the socket local IP address.","ref":"Utils.html#local_net_ip_addr/1"},{"type":"function","title":"Utils.public_ip_addr/0","doc":"Returns the public WAN ip address of the router (by having a STUN exchange with google servers).","ref":"Utils.html#public_ip_addr/0"},{"type":"function","title":"Utils.route_table/0","doc":"Returns the equivalent of running \"ip r\" on a conventional Linux OS.","ref":"Utils.html#route_table/0"},{"type":"function","title":"Utils.router_ip_addr/0","doc":"Returns the router address by inspecting the route table and looking up\nthe default route \"via\" content.\n\nThe default route and the router gateway are assumed to be unique in the routing table.\nIn other words the networking has to be plain simple: no multihoming.","ref":"Utils.html#router_ip_addr/0"}],"content_type":"text/markdown"}